#include <stdint.h>
#include <stdbool.h>
#include "inc/hw_ints.h"
#include "inc/hw_memmap.h"
#include "inc/hw_types.h"

#include "driverlib/rom.h"
#include "driverlib/pin_map.h"
#include "driverlib/sysctl.h"
#include "driverlib/systick.h"
#include "driverlib/gpio.h"

#include "gui_4094.h"
#include "key_config.h"

extern uint32_t soft_timer;

uint8_t  seconds_show ,seconds_bits_show,seconds_ten_show,minute_show,minute_bits,
         minute_ten ,hour_bits,hour_ten,hour_hundred,hour_thousand;
uint16_t hour_show;
const uint8_t		SEG_TAB[32] = {
                                        0xC0, 0xf9, 0xa4, 0xb0, 		// 0 1 2 3
                                        0x99, 0x92, 0x82, 0xf8, 		// 4 5 6 7
                                        0x80, 0x90, 0x88, 0x83, 		// 8 9 A b
                                        0xc6, 0xa1, 0x86, 0x8e, 		// C d E F
                                        0xc1, 0x9c, 0x89, 0xcf,			// U  H I
                                        0xe3, 0xab, 0x8c, 0xff,			// u n P
                                        0xc7, 0x98, 0x81, 0x87,			// L q W t
};                               //constвɱ
//0-9
const uint8_t GUI_TAB[10] =  {
	                              0xfc, 0x60, 0xda, 0xf2,             // 0 1 2 3
	                              0x66, 0xb6, 0xbe, 0xe0,             // 4 5 6 7
	                              0xfe, 0xf6,                         // 8 9
	
	
                              };



/*cd4094ʱأݴ
  CLOCK  ->   PE0
	DATA   ->   PE4
	EN     ->   PE5
  STR    ->   PE6
ӲƣCLOCK DATA EN STR3.3VĬΪߵƽ
*/
void gui_writebyte(uint8_t data_4094)
{
	//
	uint8_t  i;
	 
	//棬ԭ״̬
	  GPIOPinWrite(GPIO_PORTE_AHB_BASE , GPIO_PIN_6 , 0<<6 ); 
	for(i=0;i<8;i++)
	{
		  //ʱźŵ͵ƽ
			GPIOPinWrite(GPIO_PORTE_AHB_BASE , GPIO_PIN_0 , 0 ); 
			if((data_4094&0x01)==0x01)
			GPIOPinWrite(GPIO_PORTE_AHB_BASE , GPIO_PIN_4 , 1<<4 );
			else
			GPIOPinWrite(GPIO_PORTE_AHB_BASE , GPIO_PIN_4 , 0<<4 );	
			//ʱźŸߵƽ
			GPIOPinWrite(GPIO_PORTE_AHB_BASE , GPIO_PIN_0 , 1 ); 
			data_4094 >>= 1;
		}
	   
	  GPIOPinWrite(GPIO_PORTE_AHB_BASE , GPIO_PIN_6 , 1<<6 ); 	
	
   	
}

//ʱǰλΪӣλΪ
void gui_timeshow(void)
{
	
	 
	 //ʾ
	 seconds_show = soft_timer/1000; 
   seconds_bits_show = seconds_show%10;
	 seconds_ten_show = seconds_show/10;
   
	 minute_bits = minute_show%10;
	 minute_ten =  minute_show/10;
	
	 hour_bits = hour_show%10;
	 hour_ten =  hour_show/10;
	 hour_hundred = hour_show/100;
	 hour_thousand = hour_show/1000;
	
	 //ܲĶλȣβ󣬹дǰȰȫ
	 gui_writebyte(0x00);
	 gui_writebyte(GUI_TAB[hour_thousand]);
	 //ѡӦܣѡе1λ
	 GPIOPinWrite(GPIO_PORTH_AHB_BASE , GPIO_PIN_0|GPIO_PIN_1|GPIO_PIN_2|
	                                    GPIO_PIN_3|GPIO_PIN_4|GPIO_PIN_5|GPIO_PIN_6|GPIO_PIN_7 , 0x01  );
	 gui_writebyte(0x00);
	 gui_writebyte(GUI_TAB[hour_hundred]);
	 //ѡӦܣѡе2λ
	 GPIOPinWrite(GPIO_PORTH_AHB_BASE , GPIO_PIN_0|GPIO_PIN_1|GPIO_PIN_2|
	                                    GPIO_PIN_3|GPIO_PIN_4|GPIO_PIN_5|GPIO_PIN_6|GPIO_PIN_7 , 0x02  );
	 gui_writebyte(0x00);
	 gui_writebyte(GUI_TAB[hour_ten]);
	 GPIOPinWrite(GPIO_PORTH_AHB_BASE , GPIO_PIN_0|GPIO_PIN_1|GPIO_PIN_2|
	                                    GPIO_PIN_3|GPIO_PIN_4|GPIO_PIN_5|GPIO_PIN_6|GPIO_PIN_7 , 0x04  );
	 gui_writebyte(0x00);
	 gui_writebyte(GUI_TAB[hour_bits]);	
	 GPIOPinWrite(GPIO_PORTH_AHB_BASE , GPIO_PIN_0|GPIO_PIN_1|GPIO_PIN_2|
	                                    GPIO_PIN_3|GPIO_PIN_4|GPIO_PIN_5|GPIO_PIN_6|GPIO_PIN_7 , 0x08 );
	 gui_writebyte(0x00);
	 gui_writebyte(GUI_TAB[minute_ten]);
	 GPIOPinWrite(GPIO_PORTH_AHB_BASE , GPIO_PIN_0|GPIO_PIN_1|GPIO_PIN_2|
	                                    GPIO_PIN_3|GPIO_PIN_4|GPIO_PIN_5|GPIO_PIN_6|GPIO_PIN_7 , 0x10  );
	 gui_writebyte(0x00);
	 //ܵС
	 gui_writebyte(GUI_TAB[minute_bits]+1);
	 GPIOPinWrite(GPIO_PORTH_AHB_BASE , GPIO_PIN_0|GPIO_PIN_1|GPIO_PIN_2|
	                                    GPIO_PIN_3|GPIO_PIN_4|GPIO_PIN_5|GPIO_PIN_6|GPIO_PIN_7 , 0x20  );
	 gui_writebyte(0x00);
	 gui_writebyte(GUI_TAB[seconds_ten_show]);
	 GPIOPinWrite(GPIO_PORTH_AHB_BASE , GPIO_PIN_0|GPIO_PIN_1|GPIO_PIN_2|
	                                    GPIO_PIN_3|GPIO_PIN_4|GPIO_PIN_5|GPIO_PIN_6|GPIO_PIN_7 , 0x40  );
	 gui_writebyte(0x00);
	 gui_writebyte(GUI_TAB[seconds_bits_show]);	
	 GPIOPinWrite(GPIO_PORTH_AHB_BASE , GPIO_PIN_0|GPIO_PIN_1|GPIO_PIN_2|
	                                    GPIO_PIN_3|GPIO_PIN_4|GPIO_PIN_5|GPIO_PIN_6|GPIO_PIN_7 , 0x80 );
	 
	
	 
}




